// TWISTER 19.11.2012

unit Unit1;

interface

uses
  Windows, Classes, Graphics, Controls, Forms, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  Aborted: Boolean = false;

  cnt: byte;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var a,  x1, x2, x3, x4: integer;
    ang, amp, damp: real;
begin

ang:=0.2;

damp:=0.02;

amp:=0;

repeat

  sleep(50);

  Application.ProcessMessages; // <-- konieczna linia
  if Aborted then exit;

  with image1.Canvas do begin
   Pen.Color:=0; Brush.Color:=0;
   Rectangle(0,0,320,200);
  end;

  For a:=0 To 200 do begin

 		x1:=round(((Sin(((a*amp)*pi/180)+ang))*40)+160);
   		x2:=round(((Sin(((a*amp)*pi/180)+ang+90*pi/180))*40)+160);
     		x3:=round(((Sin(((a*amp)*pi/180)+ang+90*2*pi/180))*40)+160);
       		x4:=round(((Sin(((a*amp)*pi/180)+ang+90*3*pi/180))*40)+160);

    image1.Canvas.Pen.Color:=clRed;
    If x1<x2 then begin
      image1.Canvas.MoveTo(x1,a);
      image1.Canvas.LineTo(x2,a);
    End;

    image1.Canvas.Pen.Color:=clYellow;
    If x2<x3 then begin
      image1.Canvas.MoveTo(x2,a);
      image1.Canvas.LineTo(x3,a);
    End;

    image1.Canvas.Pen.Color:=clGreen;
    If x3<x4 then begin
      image1.Canvas.MoveTo(x3,a);
      image1.Canvas.LineTo(x4,a);
    End;

    image1.Canvas.Pen.Color:=clBlue;
    If x4<x1 then begin
      image1.Canvas.MoveTo(x4,a);
      image1.Canvas.LineTo(x1,a);
    End;

  end;

  ang:=ang+0.3;

  amp:=amp+damp;
  if (amp>1) or (amp<-1) then damp:=-damp;

until false;

end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 doublebuffered:=true;
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key=27 then Aborted:=true;
end;


end.
